
clear;

%% script ver3

%todo
%add funk for when students exceed workplace
%add funk for when workplace exceed students

%vil sitte med studenter med samme behov for arbeidsplass

%% read from table
%use enumerated data to represent placetype

%1 : Har behov for fast arbeidsplass, med PC og skjerm
%2 : Har behov for fast arbeidsplass, med skjerm
%3 : Har behov for fast arbeidsplass, uten PC-utstyr
%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet

%legge til flere kolonner
arbeidsplasser = readtable('AlleArbeidsplasser3.xlsx');
temp1 = table('Size',[height(arbeidsplasser) 1],'VariableTypes',{'logical'}, 'VariableNames',  {'allocatedtruefalse'});
arbeidsplasser = [arbeidsplasser temp1];

%legge til flere kolonner
soknader = readtable('Soknader3.xlsx', 'ReadRowNames',true);
temp2 = table('Size',[height(soknader) 6],'VariableTypes',{'string', 'string', 'uint8', 'logical', 'logical', 'logical'}, 'VariableNames',  {'allocatedroomname','allocatedplacenumber','allocatedplacetype', 'priority', 'optimize1', 'optimize2'});
outputtable = [soknader temp2];

%% Tildele ønsked plasstype for de som har søkt om drop in og ikke behov
% siden det ikke er noe begrensninger på tildeling for de type plassene

%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet
for index = 1:height(outputtable)
    if outputtable{index,1} == 4
        outputtable{index,5} = outputtable{index,1};
    elseif outputtable{index,1} == 5
        outputtable{index,5} = outputtable{index,1};
    end
end


%% Compute some numbers to use for control flow
% compute number of each type of workplace
% 
% num_of_workplace1 = 0;
% num_of_workplace2 = 0;
% num_of_workplace3 = 0;
% for index = 1:height(arbeidsplasser)
%     if arbeidsplasser{index,3} == 1
%         num_of_workplace1 = num_of_workplace1 + 1;
%     elseif arbeidsplasser{index,3} == 2
%         num_of_workplace2 = num_of_workplace2 + 1;
%     elseif arbeidsplasser{index,3} == 3
%         num_of_workplace3 = num_of_workplace3 + 1;
%     end
% end
% 
% %find number of students that want each type
% studentwantsworkplace1 = 0;
% studentwantsworkplace2 = 0;
% studentwantsworkplace3 = 0;
% for index = 1:height(outputtable)
%     if outputtable{index,2} == 1
%         studentwantsworkplace1 = studentwantsworkplace1 + 1;
%     elseif outputtable{index,2} == 2
%         studentwantsworkplace2 = studentwantsworkplace2 + 1;
%     elseif outputtable{index,2} == 3
%         studentwantsworkplace3 = studentwantsworkplace3 + 1;
%     end
% end
% 
% %% branch for when workplace exceeds students needs
% 
% if studentwantsworkplace1 > num_of_workplace1
%     priority1 = randperm(studentwantsworkplace1, num_of_workplace1);
%     
%     for index = priority1
%         outputtable{index, 7} = 1;
%     end
%     
%     
%     
% end
% 
% 
% if num_of_workplace1 >= studentwantsworkplace1
%     for index = 1:height(outputtable)
%         if outputtable{index, 2} == 1
%             for index2 = 1:height(arbeidsplasser)
%                 if arbeidsplasser{index2, 3} == 1 %check behow for arbeidsplass lik 1
%                     if (outputtable{index,6} == 0) && (arbeidsplasser{index2, 4} == 0) %hvis ikke allokert og plassen ikke er tildelt til noen andre
%                         outputtable(index,4:6) = arbeidsplasser(index2, 1:3);
%                         arbeidsplasser{index2, 4} = 1;
%                     end
%                 end
%             end
%         end
%     end
% else
%     xxx = 1;
%     
% end
% 

%% assign workplace 1

for index = 1:height(outputtable)
    if outputtable{index, 1} == 1
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 1
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

%% assign workplace 2

for index = 1:height(outputtable) % iterere over alle søknader
    if (outputtable{index, 1} == 2) || (outputtable{index, 1} == 1 && outputtable{index, 5} == 0) % hvis type ønsket plass er 2
        for index2 = 1:height(arbeidsplasser) % itere over alle arbeidsplasser
            if arbeidsplasser{index2, 3} == 2 %hvis type arbeids plass er 2
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0) % hvis 
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

%% assign workplace 3

for index = 1:height(outputtable)
    if outputtable{index, 1} == 3 || (outputtable{index, 1} == 2 && outputtable{index, 5} ~= 2) %not correct here I think.
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 3
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end


%% går gjennom linje for linje, 


% applicationtable = readtable('applications.xls','ReadRowNames',true);
% 
% 
% outputcost = computecost(roomtable, applicationtable);
% 
% 
% 
% 
% %% export at end
% 
% writetable(godkjentetable,'godkjente.xls','WriteRowNames',true);