clear;

%% dumb script ver1
%% read from table

%use enumerated data to represent placetype

%1 : Har behov for fast arbeidsplass, med PC og skjerm
%2 : Har behov for fast arbeidsplass, med skjerm
%3 : Har behov for fast arbeidsplass, uten PC-utstyr
%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet

arbeidsplasser = readtable('AlleArbeidsplasser2.xlsx');
temp1 = table('Size',[height(arbeidsplasser) 1],'VariableTypes',{'logical'}, 'VariableNames',  {'allocatedtruefalse'});
arbeidsplasser = [arbeidsplasser temp1];

soknader = readtable('Soknader2.xlsx');
temp2 = table('Size',[height(soknader) 3],'VariableTypes',{'string', 'string', 'uint8'}, 'VariableNames',  {'allocatedroomname','allocatedplacenumber','allocatedplacetype'});
outputtable = [soknader temp2];


%%starte med å initialisere
%% tildele alle ressurser initielt

%iterate table, give all students for 
%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet
%what they want
for index = 1:height(outputtable)
    if outputtable{index,3} == 4
        outputtable{index,6} = outputtable{index,3};
    elseif outputtable{index,3} == 5
        outputtable{index,6} = outputtable{index,3};
    end
end

%% compute numbers
%%compute number of each type of workplace
num_of_workplace1 = 0;
num_of_workplace2 = 0;
num_of_workplace3 = 0;
for index = 1:height(arbeidsplasser)
    if arbeidsplasser{index,3} == 1
        num_of_workplace1 = num_of_workplace1 + 1;
    elseif arbeidsplasser{index,3} == 2
        num_of_workplace2 = num_of_workplace2 + 1;
    elseif arbeidsplasser{index,3} == 3
        num_of_workplace3 = num_of_workplace3 + 1;
    end
end

%find number of students that want yeach type
studentwantsworkplace1 = 0;
studentwantsworkplace2 = 0;
studentwantsworkplace3 = 0;
for index = 1:height(outputtable)
    if outputtable{index,3} == 1
        studentwantsworkplace1 = studentwantsworkplace1 + 1;
    elseif outputtable{index,3} == 2
        studentwantsworkplace2 = studentwantsworkplace2 + 1;
    elseif outputtable{index,3} == 3
        studentwantsworkplace3 = studentwantsworkplace3 + 1;
    end
end

%% assign workplace 1

for index = 1:height(outputtable)
    if outputtable{index, 3} == 1
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 1
                if (outputtable{index,6} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,4:6) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

%% assign workplace 2

for index = 1:height(outputtable)
    if outputtable{index, 3} == 2
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 2
                if (outputtable{index,6} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,4:6) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

%% assign workplace 3

for index = 1:height(outputtable)
    if outputtable{index, 3} == 3 || (outputtable{index, 3} == 2 && outputtable{index, 6} ~= 2) %not correct here I think.
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 3
                if (outputtable{index,6} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,4:6) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end


%% går gjennom linje for linje, 


% applicationtable = readtable('applications.xls','ReadRowNames',true);
% 
% 
% outputcost = computecost(roomtable, applicationtable);
% 
% 
% 
% 
% %% export at end
% 
% writetable(godkjentetable,'godkjente.xls','WriteRowNames',true);